/* Sistemas Integrados TECNISA

Nome: 00ND_GERTRGS_DTULTATU_TIPOPERDA.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela TIPOPERDA

Criao:
21/04/2007 Ronald Reis
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOPERDA' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
  DROP TRIGGER DTULTATU_TIPOPERDA
  GO

CREATE TRIGGER DTULTATU_TIPOPERDA
ON TIPOPERDA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOPERDA', 'CDTIPOPERDA=' + CDTIPOPERDA+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOPERDA
      SET  DTULTATUTPER = GETDATE()
      FROM INSERTED
      WHERE ISNULL(TIPOPERDA.CDTIPOPERDA,0) = ISNULL(INSERTED.CDTIPOPERDA,0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPOPERDA','4.11.134';
GO
