/* Sistemas Integrados TEKNISA
   Compras e Suprimentos
   Nome: 8200_CMPSTPO.sql
   Descrio:
   Procedimento para criao dos impostos na rotina de fechamento da AF.
   Criao:
   04/05/1999 Yoris L. de Souza */

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'IMPOSTO_ITEMAF'  and
            type = 'P'                  and
            u.uid = o.uid               and 
            u.name = USER)
  DROP PROCEDURE IMPOSTO_ITEMAF
  GO

CREATE PROCEDURE IMPOSTO_ITEMAF @P_EMPRESA    VARCHAR(2),
                                @P_INSCESTA   varchar(16),
                                @P_FORNECEDOR VARCHAR(21),
                                @P_FILDEST    VARCHAR(4),
                                @P_FILLANC    VARCHAR(4),
                                @P_LANCTOAF   VARCHAR(10),
                                @P_INIVALID   DATETIME
AS
   DECLARE @V_PAISORIG      VARCHAR(04);
   DECLARE @V_ESTAORIG      VARCHAR(02);
   DECLARE @V_MUNIORIG      VARCHAR(04);
   DECLARE @V_PAISDEST      VARCHAR(04);
   DECLARE @V_ESTADEST      VARCHAR(02);
   DECLARE @V_ALIQTEMP      VARCHAR(18);
   DECLARE @V_INCITEMP      VARCHAR(18);
   DECLARE @V_TIPOOPER      VARCHAR(02);
   DECLARE @V_CARACFIS      VARCHAR(01);
   DECLARE @V_LIQUIITEM     NUMERIC(15,6);
   DECLARE @V_PARDEDTMP     NUMERIC(15,6);
   DECLARE @V_PREDBCTMP     NUMERIC(15,6);
   DECLARE @V_ALIQUTMP      NUMERIC(15,6);
   DECLARE @V_IMPOSTOIT     NUMERIC(15,6);
   DECLARE @V_TAXABASECALC  NUMERIC(15,6);
   DECLARE @V_TAXAALIQUOTA  NUMERIC(15,6);
   DECLARE @V_BASECALCIT    NUMERIC(15,6);
   DECLARE @V_CONTABCALC    NUMERIC(15,6);
   DECLARE @V_PERDBCALC     NUMERIC(15,6);
   DECLARE @V_ADIMPAF       NUMERIC(15,6);
   DECLARE @V_TOTAIMPBCALC  NUMERIC(15,6);
   DECLARE @V_TOTAPRODENCA  NUMERIC(15,6);
   DECLARE @V_PRODUENCARGO  NUMERIC(15,6);
   DECLARE @V_IDCSTINTEREST VARCHAR(01);
   DECLARE @V_IDCSTINTERNA  VARCHAR(01);

   /*VARIVEIS DO CURSOR C_ITEMAUTF*/
   DECLARE @V_ITEMAUTF_QTPROGENTAF NUMERIC(10,3);
   DECLARE @V_ITEMAUTF_VRPREUNIAF  NUMERIC(15,5);
   DECLARE @V_ITEMAUTF_VRPERDESAF  NUMERIC(6,2);
   DECLARE @V_ITEMAUTF_CDPRODUTO   VARCHAR(10);
   DECLARE @V_ITEMAUTF_CDARVPROD   VARCHAR(20);
   DECLARE @V_ITEMAUTF_CDMARCA     VARCHAR(5);
   DECLARE @V_ITEMAUTF_DTPROGENTAF DATETIME;

   /*VARIVEIS DO CURSOR C_INCIDENCIA*/
   DECLARE @V_INCIDEN_CDIMPOTEMP  VARCHAR(2);
   DECLARE @V_INCIDEN_CDFISCTEMP  VARCHAR(1);
   DECLARE @V_INCIDEN_IDTRATIMPO  VARCHAR(1);
   DECLARE @V_INCIDEN_IDIMPORECUP VARCHAR(1);

   /*VARIVEIS DO CURSOR C_DATAITEM*/
   DECLARE @V_DATAITEM_DTPROGENTAF DATETIME;

   /*VARIVEIS DO CURSOR C_ENCARGO*/
   DECLARE @V_ENC_CDENCARGO   VARCHAR(2);
   DECLARE @V_ENC_VRENCARGOAF NUMERIC(16,2);
   DECLARE @V_ENC_IDENCARGO   VARCHAR(1);

   /*VARIVEIS DO CURSOR C_VRLIQRATEIO*/
   DECLARE @V_RATEIO_CDPRODUTO VARCHAR(10);
   DECLARE @V_RATEIO_CDMARCA   VARCHAR(5);
   DECLARE @V_RATEIO_VRLIQUIDO NUMERIC(15,6);

   /*VARIVEIS DO CURSOR C_IMPOSTOAF*/
   DECLARE @V_IMPOSTOAF_CDPRODUTO     VARCHAR(10);
   DECLARE @V_IMPOSTOAF_CDMARCA       VARCHAR(5);
   DECLARE @V_IMPOSTOAF_VRPERREDBCAF  NUMERIC(10,2);
   DECLARE @V_IMPOSTOAF_VRALIQITMAF   NUMERIC(10,2);
   DECLARE @V_IMPOSTOAF_VRPARCDEDAF   NUMERIC(16,2);
   DECLARE @V_IMPOSTOAF_VRIMPITMAF    NUMERIC(16,2);
   DECLARE @V_IMPOSTOAF_CDIMPOSTO     VARCHAR(2);
   DECLARE @V_IMPOSTOAF_IDTRATIMPO    VARCHAR(1);
   DECLARE @V_IMPOSTOAF_CDFISCITMAF   VARCHAR(1);
   DECLARE @V_IMPOSTOAF_IDIMPORECUP   VARCHAR(1);
   DECLARE @V_IMPOSTOAF_VRLIQUIDO     NUMERIC(15,6);

   /*VARIVEIS DO CURSOR C_PRODUTO*/
   DECLARE @V_PRODUTO_CDPRODUTO    VARCHAR(10);
   DECLARE @V_PRODUTO_CDMARCA      VARCHAR(5);
   DECLARE @V_PRODUTO_DTPROGENTAF  DATETIME;
   DECLARE @V_PRODUTO_CDIMPOSTO    VARCHAR(2);
   DECLARE @V_PRODUTO_VRPERREDBCAF NUMERIC(10,2);
   DECLARE @V_PRODUTO_VRALIQITMAF  NUMERIC(10,2);
   DECLARE @V_PRODUTO_VRPARCDEDAF  NUMERIC(16,2);
   DECLARE @V_PRODUTO_CDFISCITMAF  VARCHAR(1);
   DECLARE @V_PRODUTO_VRIMPITMAF   NUMERIC(16,2);
   DECLARE @V_PRODUTO_IDTRATIMPO   VARCHAR(1);
   DECLARE @V_PRODUTO_IDIMPORECUP  VARCHAR(1);
   DECLARE @V_STRING_AUX           VARCHAR(2000);
   DECLARE @V_NRIMPDIGI            INT;
   DECLARE @V_VRIMPITAFAUX         NUMERIC(16,2);

   DECLARE @V_CDGRUPOFISC          VARCHAR(3);

   DECLARE @V_IDTRATIMPBC   VARCHAR(1);
   DECLARE @V_IDIMPORECUPBC VARCHAR(1);

   DECLARE @V_CSTTEMP  VARCHAR(18);
   DECLARE @V_CFOPTEMP VARCHAR(18);

   DECLARE @V_FISOPEITEM VARCHAR(11);
   DECLARE @V_SITUTRIBPR VARCHAR(03);

   DECLARE @V_AUX VARCHAR(8);

   DECLARE @V_CDIMPOBCALTPOP VARCHAR(2);


   DECLARE @V_TAXABCSUBSTR NUMERIC(16,2);
   DECLARE @V_PBCSUBTRIB   NUMERIC(16,2);
   DECLARE @V_BASEVLRMAX   NUMERIC(16,2);
   DECLARE @V_VRMAXVENDA   NUMERIC(16,2);
   DECLARE @V_CALCVLRMAX   NUMERIC(16,2);
   DECLARE @V_VRPEMAXVENDA NUMERIC(16,2);
   DECLARE @V_IDPMCBASECAL VARCHAR(01);
   DECLARE @V_CDIMPOSTRIB  VARCHAR(250);
   DECLARE @V_IDVRIMPSTRIB VARCHAR(01);
   DECLARE @V_VRIMPITMAF   NUMERIC(16,2);
   DECLARE @V_ICMSST_CDIMPOSTO VARCHAR(02);

BEGIN
   SET @V_CSTTEMP  = @P_FILDEST+@P_FILLANC+@P_LANCTOAF;
   SET @V_CFOPTEMP = @P_FILDEST+@P_FILLANC+@P_LANCTOAF;

   EXEC CONSULTA_GRUPOFISCAL 'F', @P_FORNECEDOR, '', 'E', '01', @P_CDGRUPOFISC = @V_CDGRUPOFISC OUTPUT;

--Variveis com a chave para as tabelas temporrias

   SET @V_ALIQTEMP = @P_FILDEST + @P_FILLANC + @P_LANCTOAF;
   SET @V_INCITEMP = @P_FILDEST + @P_FILLANC + @P_LANCTOAF;
---------------------------------------------------------------------------------------------------------

--Variveis para consulta de Alquota, Incidncia
   SELECT @V_PAISDEST = MAX(CDPAIS),
          @V_ESTADEST = MAX(SGESTADO)
   FROM INSCRESTAD
   WHERE (CDEMPRESA  = @P_EMPRESA) AND
         (CDINSCESTA = @P_INSCESTA);

   SELECT @V_PAISORIG = MAX(CDPAIS),
          @V_ESTAORIG = MAX(SGESTADO),
          @V_MUNIORIG = MAX(CDMUNICIPIO)
   FROM ENDEFORN
   WHERE (CDFORNECED   = @P_FORNECEDOR) AND
         (IDTPENDEFORN = 'P');

   SET @V_IDCSTINTEREST = 'N';
   SET @V_IDCSTINTERNA = 'N';
   IF (@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG) BEGIN
      SET @V_IDCSTINTEREST = 'S';
   END;

   IF (@V_PAISDEST <> @V_PAISORIG) BEGIN
      SET @V_IDCSTINTERNA = 'S';
   END;

   SELECT @V_TIPOOPER = ISNULL(MAX(PARCMPSUP.CDTIPOOPER), '01')
   FROM PARCMPSUP,
        FILIAL
   WHERE
     (FILIAL.CDFILIAL    = @P_FILDEST) AND
     (PARCMPSUP.CDFILIAL = ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL));

   SELECT @V_CARACFIS = MAX(IDCARACFIS)
   FROM PARAMFILIAL
   WHERE CDFILIAL = @P_FILDEST;
---------------------------------------------------------------------------------------------------------

-- Atualizao da tabela de ItemAutF

   DECLARE C_ITEMAUTF CURSOR FOR
   SELECT QTPROGENTAF, VRPREUNIAF, VRPERDESAF, ITEMAUTF.CDPRODUTO, CDARVPROD,
          CDMARCA, DTPROGENTAF
   FROM ITEMAUTF,
        PRODUTO
   WHERE CDFILDEST  = @P_FILDEST AND
         CDFILLANC  = @P_FILLANC AND
         ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO AND
         NRAUTOFORN = @P_LANCTOAF;

   OPEN C_ITEMAUTF;

   FETCH NEXT FROM C_ITEMAUTF INTO @V_ITEMAUTF_QTPROGENTAF, @V_ITEMAUTF_VRPREUNIAF,
                                   @V_ITEMAUTF_VRPERDESAF, @V_ITEMAUTF_CDPRODUTO,
                                   @V_ITEMAUTF_CDARVPROD, @V_ITEMAUTF_CDMARCA,
                                   @V_ITEMAUTF_DTPROGENTAF;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN

      IF (@V_ITEMAUTF_VRPERDESAF IS NULL)
      BEGIN
         SET @V_LIQUIITEM = (@V_ITEMAUTF_VRPREUNIAF * @V_ITEMAUTF_QTPROGENTAF);
      END
      ELSE BEGIN
         SET @V_LIQUIITEM = (@V_ITEMAUTF_VRPREUNIAF * @V_ITEMAUTF_QTPROGENTAF) * ((100 - @V_ITEMAUTF_VRPERDESAF)/100);
      END;


      SET @V_STRING_AUX = @P_FILDEST+@P_FILLANC;
      EXEC CONSULTA_INCIDENCIA 'E',  @P_EMPRESA,  @V_ITEMAUTF_CDARVPROD, @P_INSCESTA,
                               @V_TIPOOPER, @V_STRING_AUX, @P_LANCTOAF, @V_CDGRUPOFISC, NULL, V_IDCSTINTEREST;

---------------------------------------------------------------------------------------------------------
--Atualizao da tabela de impostos por item.

      DELETE IMPITMAF
      WHERE (CDFILDEST   = @P_FILDEST)  AND
            (CDFILLANC   = @P_FILLANC)  AND
            (NRAUTOFORN  = @P_LANCTOAF) AND
            (CDMARCA     = @V_ITEMAUTF_CDMARCA)     AND
            (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF) AND
            (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)   AND
            (IDIMPDIGAF  = 'N');


      DECLARE C_INCIDENCIA CURSOR FOR
      SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP,
             IP.IDTRATIMPO, IP.IDIMPORECUP
      FROM INCITEMP IT, IMPOSTO IP
      WHERE (IT.NRINCITEMP = @V_INCITEMP)    AND
            (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
            (IP.IDPRODNOTA = 'P')
      ORDER BY CDIMPOTEMP;

      OPEN C_INCIDENCIA;
      FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDEN_CDIMPOTEMP, @V_INCIDEN_CDFISCTEMP,
                                        @V_INCIDEN_IDTRATIMPO, @V_INCIDEN_IDIMPORECUP;

      WHILE (@@FETCH_STATUS = 0)
      BEGIN

         SET @V_STRING_AUX = @P_FILDEST+@P_FILLANC;
         EXEC CONSULTA_ALIQUOTA @V_INCIDEN_CDIMPOTEMP, 'E', @P_EMPRESA,
                                @V_ITEMAUTF_CDARVPROD, @P_INSCESTA, @V_PAISORIG,
                                @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG,
                                @V_LIQUIITEM, @P_INIVALID, @V_STRING_AUX, @P_LANCTOAF, @V_CDGRUPOFISC, @V_TIPOOPER;

         SET @V_PARDEDTMP  = 0;
         SET @V_PREDBCTMP  = 0;
         SET @V_ALIQUTMP   = 0;
         SET @V_IMPOSTOIT  = 0;

         SELECT @V_PARDEDTMP    = ISNULL(MAX(VRPARDEDTMP),0),
                @V_PREDBCTMP    = ISNULL(MAX(VRPREDBCTMP),0),
                @V_ALIQUTMP     = ISNULL(MAX(VRALIQUTMP),0),
                @V_PBCSUBTRIB   = ISNULL(MAX(VRPBCSTTMP),0),
                @V_IDPMCBASECAL = ISNULL(MAX(IDPMCBSCALTMP), 'S')
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = @V_ALIQTEMP);

         IF (@V_ALIQUTMP IS NULL)
-- OR (@V_INCIDEN_IDIMPORECUP = 'S' AND @V_INCIDEN_CDFISCTEMP <> '1')
         BEGIN
            SET @V_ALIQUTMP = 0;
         END;

         IF (@V_PREDBCTMP IS NULL)
         BEGIN
            SET @V_PREDBCTMP = 0;
         END;

         IF (@V_PARDEDTMP IS NULL)
         BEGIN
             SET @V_PARDEDTMP = 0;
         END;

         SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
         SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
         SET @V_TAXABCSUBSTR = 1+(@V_PBCSUBTRIB/100);
         SET @V_BASECALCIT   = @V_LIQUIITEM * @V_TAXABASECALC;
         SET @V_IMPOSTOIT    = ((@V_LIQUIITEM * @V_TAXABASECALC) * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

         IF @V_PBCSUBTRIB > 0 BEGIN
            SET @V_BASECALCIT = (@V_BASECALCIT * @V_TAXABCSUBSTR);
            SET @V_PREDBCTMP  = @V_PBCSUBTRIB;
         END;

         SET @V_BASEVLRMAX   = 0;
         SET @V_VRPEMAXVENDA = 0;
         SET @V_VRMAXVENDA   = 0;
         SET @V_CALCVLRMAX   = 0;

         /*VALOR MAXIMO DE VENDA AO COSUMIDOR*/
         SELECT @V_VRMAXVENDA   = ISNULL(MAX(VRMAXVENDA),0),
                @V_VRPEMAXVENDA = ISNULL(MAX(VRPEMAXVENDA),0)
           FROM VRMAXVENPROD A
          WHERE (CDPAIS   = @V_PAISDEST)          AND
                (SGESTADO = @V_ESTADEST)          AND
                (A.CDPRODUTO = @V_ITEMAUTF_CDPRODUTO);

         IF @V_VRMAXVENDA IS NOT NULL BEGIN
            SET @V_CALCVLRMAX = (@V_ITEMAUTF_QTPROGENTAF * @V_VRMAXVENDA) * (@V_VRPEMAXVENDA/100);
            SET @V_BASEVLRMAX = @V_CALCVLRMAX;
         END;

         /*IMPOSTO DE SUBSTITUICAO TRIBUTARIA*/

         DECLARE C_ICMSST CURSOR FOR
         SELECT CDIMPOSTO
                                FROM IMPOSTO
                               WHERE CDIMPOSTRIB = @V_INCIDEN_CDIMPOTEMP;

         OPEN C_ICMSST;
         FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTO;
         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            SET @V_CDIMPOSTRIB = @V_CDIMPOSTRIB+@V_ICMSST_CDIMPOSTO+'_';
            FETCH NEXT FROM C_ICMSST INTO @V_ICMSST_CDIMPOSTO;
         END;
         CLOSE C_ICMSST;
         DEALLOCATE C_ICMSST;

         IF (@V_CDIMPOSTRIB IS NULL) BEGIN
            SET @V_IMPOSTOIT    = ((@V_LIQUIITEM * @V_TAXABASECALC) * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
         END
         ELSE BEGIN
         /*Se o parametro de "Utiliza PMC" estiver marcado eu comparo o percentual de majorao com o valor maximo
           de venda e o maior entra na base de calculo. Se o parametro estiver desmarcado sempre sera utilizado o percentual de
           majorao */
            IF ISNULL(@V_IDPMCBASECAL, 'S') = 'S' BEGIN
               IF @V_BASECALCIT > @V_BASEVLRMAX BEGIN
                  SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
               END
               ELSE BEGIN
                  SET @V_IMPOSTOIT   = (@V_BASEVLRMAX * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
               END;
            END
            ELSE BEGIN
               SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
            END;

            SELECT @V_IDVRIMPSTRIB = ISNULL(MAX(IDVRIMPSTRIB), 'N')
              FROM IMPITMAF I, IMPOSTO II
             WHERE (I.CDFILDEST   = @P_FILDEST)
               AND (I.CDFILLANC   = @P_FILLANC)
               AND (I.NRAUTOFORN  = @P_LANCTOAF)
               AND (I.CDMARCA     = @V_ITEMAUTF_CDMARCA)
               AND (I.DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF)
               AND (I.CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)
               AND (CHARINDEX(II.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0)
               AND (I.CDIMPOSTO = II.CDIMPOSTO);

            IF (ISNULL(@V_IDVRIMPSTRIB,'N') = 'N') BEGIN
               SET @V_VRIMPITMAF = 0;
            END
            ELSE BEGIN
                SELECT @V_VRIMPITMAF = ISNULL(MAX(VRIMPITMAF),0)
                  FROM IMPITMAF I
                 WHERE (I.CDFILDEST   = @P_FILDEST)
                   AND (I.CDFILLANC   = @P_FILLANC)
                   AND (I.NRAUTOFORN  = @P_LANCTOAF)
                   AND (I.CDMARCA     = @V_ITEMAUTF_CDMARCA)
                   AND (I.DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF)
                   AND (I.CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)
                   AND (CHARINDEX(I.CDIMPOSTO+'_', @V_CDIMPOSTRIB) > 0);
            END;
            SET @V_IMPOSTOIT = @V_IMPOSTOIT - @V_VRIMPITMAF;
         END;

         IF (@V_IMPOSTOIT < 0) BEGIN
            SET @V_IMPOSTOIT = 0;
         END;

         SET @V_ADIMPAF = 0;

         IF (@V_INCIDEN_IDTRATIMPO = 'A')
         BEGIN
            SET @V_ADIMPAF = @V_IMPOSTOIT;

         END
         ELSE IF (@V_INCIDEN_IDTRATIMPO = 'D')
         BEGIN
            SET @V_ADIMPAF = - @V_IMPOSTOIT;

         END;

--- * RETIRADO PARA TRATAMENTO SOMENTE NA GERACAO DE VENCIMENTO
--         ELSIF (@V_INCIDEN_IDTRATIMPO = 'R') THEN
--            IF (@V_INCIDEN_IDIMPORECUP = 'S') THEN
--               IF (@V_CARACFIS = 'N' OR (@V_CARACFIS  = 'C' AND @V_INCIDEN_CDFISCTEMP <> '1')) THEN
--                  @V_ADIMPAF = - @V_IMPOSTOIT;
--               END IF;
--            ELSE
--               @V_ADIMPAF = - @V_IMPOSTOIT;
--            END IF;
--         END IF;
         SET @V_NRIMPDIGI = 0;
         SELECT @V_NRIMPDIGI = COUNT(*)
         FROM IMPITMAF
         WHERE (CDFILDEST   = @P_FILDEST)  AND
               (CDFILLANC   = @P_FILLANC)  AND
               (NRAUTOFORN  = @P_LANCTOAF) AND
               (CDMARCA     = @V_ITEMAUTF_CDMARCA)     AND
               (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF) AND
               (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)   AND
               (CDIMPOSTO   = @V_INCIDEN_CDIMPOTEMP);

         IF @V_NRIMPDIGI = 0
         BEGIN
           INSERT INTO IMPITMAF(
              CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO, CDMARCA, DTPROGENTAF,
              CDIMPOSTO, VRIMPITMAF, VRPERREDBCAF, VRBASECALCAF,
              VRALIQITMAF, VRPARCDEDAF, CDFISCITMAF, VRADIMPAF)
           VALUES(
              @P_FILDEST, @P_FILLANC, @P_LANCTOAF, @V_ITEMAUTF_CDPRODUTO, @V_ITEMAUTF_CDMARCA, @V_ITEMAUTF_DTPROGENTAF,
              @V_INCIDEN_CDIMPOTEMP, ROUND(@V_IMPOSTOIT, 2), @V_PREDBCTMP, @V_BASECALCIT, @V_ALIQUTMP,
              @V_PARDEDTMP, @V_INCIDEN_CDFISCTEMP, ROUND(@V_ADIMPAF, 2));
         END
         ELSE
         BEGIN
            SET @V_VRIMPITAFAUX = NULL;
            SELECT @V_VRIMPITAFAUX = VRADIMPAF
            FROM IMPITMAF
            WHERE (CDFILDEST   = @P_FILDEST)  AND
                 (CDFILLANC   = @P_FILLANC)  AND
                 (NRAUTOFORN  = @P_LANCTOAF) AND
                 (CDMARCA     = @V_ITEMAUTF_CDMARCA)     AND
                 (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF) AND
                 (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)   AND
                 (CDIMPOSTO   = @V_INCIDEN_CDIMPOTEMP);

            IF (@V_INCIDEN_IDTRATIMPO = 'D')
            BEGIN
              SET @V_VRIMPITAFAUX = -@V_VRIMPITAFAUX;
            END;
            IF (@V_INCIDEN_IDTRATIMPO <> 'V')
            BEGIN
               UPDATE IMPITMAF
               SET VRADIMPAF = ROUND(@V_VRIMPITAFAUX, 2)
               WHERE (CDFILDEST   = @P_FILDEST)  AND
                    (CDFILLANC   = @P_FILLANC)  AND
                    (NRAUTOFORN  = @P_LANCTOAF) AND
                    (CDMARCA     = @V_ITEMAUTF_CDMARCA)     AND
                    (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF) AND
                    (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)   AND
                    (CDIMPOSTO   = @V_INCIDEN_CDIMPOTEMP);
            END;

         END;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @V_ALIQTEMP;

         FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDEN_CDIMPOTEMP, @V_INCIDEN_CDFISCTEMP,
                                           @V_INCIDEN_IDTRATIMPO, @V_INCIDEN_IDIMPORECUP;
      END;

      CLOSE C_INCIDENCIA;
      DEALLOCATE C_INCIDENCIA;

      DELETE INCITEMP
      WHERE NRINCITEMP = @V_INCITEMP;

      FETCH NEXT FROM C_ITEMAUTF INTO @V_ITEMAUTF_QTPROGENTAF, @V_ITEMAUTF_VRPREUNIAF,
                                      @V_ITEMAUTF_VRPERDESAF, @V_ITEMAUTF_CDPRODUTO,
                                      @V_ITEMAUTF_CDARVPROD, @V_ITEMAUTF_CDMARCA,
                                      @V_ITEMAUTF_DTPROGENTAF;
   END;

   CLOSE C_ITEMAUTF;
   DEALLOCATE C_ITEMAUTF;


   --------------------------------------------------------------------------------------------------------
   --Rateio dos Encargos.

   DECLARE C_DATAITEM CURSOR FOR
   SELECT DISTINCT DTPROGENTAF
   FROM   ITEMAUTF
   WHERE (CDFILLANC   = @P_FILLANC)  AND
         (CDFILDEST   = @P_FILDEST)  AND
         (NRAUTOFORN  = @P_LANCTOAF);

   OPEN C_DATAITEM;

   FETCH NEXT FROM C_DATAITEM INTO @V_DATAITEM_DTPROGENTAF;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      DECLARE C_ENCARGO CURSOR FOR
      SELECT E.CDENCARGO, VRENCARGOAF, IDENCARGO
      FROM ENCARGOAF E, ENCARGO EC
      WHERE (CDFILLANC   = @P_FILLANC)    AND
            (CDFILDEST   = @P_FILDEST)    AND
            (NRAUTOFORN  = @P_LANCTOAF)   AND
            (VRENCARGOAF > 0)            AND
            (E.CDENCARGO = EC.CDENCARGO) AND
            (DTENTRENCAF = @V_DATAITEM_DTPROGENTAF);

      OPEN C_ENCARGO;
      FETCH NEXT FROM C_ENCARGO INTO @V_ENC_CDENCARGO, @V_ENC_VRENCARGOAF,
                                     @V_ENC_IDENCARGO;

      WHILE (@@FETCH_STATUS = 0)
      BEGIN
         SET @V_TOTAPRODENCA = 0;
         DECLARE C_VRLIQRATEIO CURSOR FOR
         SELECT DISTINCT I.CDPRODUTO, I.CDMARCA,
                (VRPREUNIAF * QTPROGENTAF) AS VRLIQUIDO
         FROM ITEMAUTF I, IMPITMAF II
         WHERE (I.CDFILLANC   = @P_FILLANC)              AND
               (I.CDFILDEST   = @P_FILDEST)              AND
               (I.NRAUTOFORN  = @P_LANCTOAF)             AND
               (II.CDFILLANC  = @P_FILLANC)              AND
               (II.CDFILDEST  = @P_FILDEST)              AND
               (II.NRAUTOFORN = @P_LANCTOAF)             AND
               (I.CDPRODUTO   = II.CDPRODUTO)           AND
               (I.CDMARCA     = II.CDMARCA)             AND
               (I.DTPROGENTAF = @V_DATAITEM_DTPROGENTAF) AND
               (I.DTPROGENTAF = II.DTPROGENTAF)         AND
               (II.IDIMPDIGAF  = 'N')                   AND
               (I.VRPERDESAF IS NULL)                   AND
               (II.CDIMPOSTO IN (SELECT MAX(BC.CDIMPOSTO)
                                 FROM BASECALC BC
                                 WHERE (BC.CDENCARGO = @V_ENC_CDENCARGO)))
         UNION
         SELECT DISTINCT I.CDPRODUTO, I.CDMARCA,
                ((VRPREUNIAF * QTPROGENTAF)*((100 - VRPERDESAF)/100)) AS VRLIQUIDO
         FROM ITEMAUTF I, IMPITMAF II
         WHERE (I.CDFILLANC   = @P_FILLANC)              AND
               (I.CDFILDEST   = @P_FILDEST)              AND
               (I.NRAUTOFORN  = @P_LANCTOAF)             AND
               (II.CDFILLANC  = @P_FILLANC)              AND
               (II.CDFILDEST  = @P_FILDEST)              AND
               (II.NRAUTOFORN = @P_LANCTOAF)             AND
               (I.CDPRODUTO   = II.CDPRODUTO)           AND
               (I.CDMARCA     = II.CDMARCA)             AND
               (I.DTPROGENTAF = @V_DATAITEM_DTPROGENTAF) AND
               (I.DTPROGENTAF = II.DTPROGENTAF)         AND
               (II.IDIMPDIGAF  = 'N')                   AND
               (I.VRPERDESAF IS NOT NULL)               AND
               (II.CDIMPOSTO IN (SELECT MAX(BC.CDIMPOSTO)
                                 FROM BASECALC BC
                                 WHERE (BC.CDENCARGO = @V_ENC_CDENCARGO)));

         OPEN C_VRLIQRATEIO;
         FETCH NEXT FROM C_VRLIQRATEIO INTO @V_RATEIO_CDPRODUTO, @V_RATEIO_CDMARCA,
                                            @V_RATEIO_VRLIQUIDO;
         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            IF NOT (@V_RATEIO_VRLIQUIDO IS NULL)
            BEGIN
               SET @V_TOTAPRODENCA = @V_TOTAPRODENCA + @V_RATEIO_VRLIQUIDO;
            END;
            FETCH NEXT FROM C_VRLIQRATEIO INTO @V_RATEIO_CDPRODUTO, @V_RATEIO_CDMARCA,
                                               @V_RATEIO_VRLIQUIDO;
         END;
         CLOSE C_VRLIQRATEIO;
         DEALLOCATE C_VRLIQRATEIO;

         IF (@V_TOTAPRODENCA > 0)
         BEGIN

            DECLARE C_IMPOSTOAF CURSOR FOR
            SELECT I.CDPRODUTO, I.CDMARCA, VRPERREDBCAF, VRALIQITMAF,
                                       VRPARCDEDAF, VRIMPITMAF, II.CDIMPOSTO, IDTRATIMPO,
                                       CDFISCITMAF, IDIMPORECUP,
                                       (VRPREUNIAF * QTPROGENTAF) AS VRLIQUIDO
            FROM ITEMAUTF I, IMPITMAF II, BASECALC B, IMPOSTO IM, PRODUTO
            WHERE (I.CDFILLANC   = @P_FILLANC)              AND
                  (I.CDFILDEST   = @P_FILDEST)              AND
                  (I.NRAUTOFORN  = @P_LANCTOAF)             AND
                  (II.CDFILLANC  = @P_FILLANC)              AND
                  (II.CDFILDEST  = @P_FILDEST)              AND
                  (II.NRAUTOFORN = @P_LANCTOAF)             AND
                  (I.CDPRODUTO   = II.CDPRODUTO)           AND
                  (I.CDMARCA     = II.CDMARCA)             AND
                  (I.DTPROGENTAF = @V_DATAITEM_DTPROGENTAF) AND
                  (I.DTPROGENTAF = II.DTPROGENTAF)         AND
                  (II.IDIMPDIGAF  = 'N')                   AND
                  (II.CDIMPOSTO  = B.CDIMPOSTO)            AND
                  (II.CDIMPOSTO  = IM.CDIMPOSTO)           AND
                  (I.VRPERDESAF IS NULL)                   AND
                  (B.CDENCARGO   = @V_ENC_CDENCARGO)
            UNION
            SELECT I.CDPRODUTO, I.CDMARCA, VRPERREDBCAF, VRALIQITMAF,
                   VRPARCDEDAF, VRIMPITMAF, II.CDIMPOSTO, IDTRATIMPO,
                   CDFISCITMAF, IDIMPORECUP,
                   ((VRPREUNIAF * QTPROGENTAF)*((100 - VRPERDESAF)/100)) AS VRLIQUIDO
            FROM ITEMAUTF I, IMPITMAF II, BASECALC B, IMPOSTO IM
            WHERE (I.CDFILLANC   = @P_FILLANC)              AND
                  (I.CDFILDEST   = @P_FILDEST)              AND
                  (I.NRAUTOFORN  = @P_LANCTOAF)             AND
                  (II.CDFILLANC  = @P_FILLANC)              AND
                  (II.CDFILDEST  = @P_FILDEST)              AND
                  (II.NRAUTOFORN = @P_LANCTOAF)             AND
                  (I.CDPRODUTO   = II.CDPRODUTO)           AND
                  (I.CDMARCA     = II.CDMARCA)             AND
                  (I.DTPROGENTAF = @V_DATAITEM_DTPROGENTAF) AND
                  (I.DTPROGENTAF = II.DTPROGENTAF)         AND
                  (II.IDIMPDIGAF  = 'N')                   AND
                  (II.CDIMPOSTO  = B.CDIMPOSTO)            AND
                  (II.CDIMPOSTO  = IM.CDIMPOSTO)           AND
                  (I.VRPERDESAF IS NOT NULL)               AND
                  (B.CDENCARGO   = @V_ENC_CDENCARGO);

            OPEN C_IMPOSTOAF;
            FETCH NEXT FROM C_IMPOSTOAF INTO @V_IMPOSTOAF_CDPRODUTO   , @V_IMPOSTOAF_CDMARCA,
                                             @V_IMPOSTOAF_VRPERREDBCAF, @V_IMPOSTOAF_VRALIQITMAF,
                                             @V_IMPOSTOAF_VRPARCDEDAF , @V_IMPOSTOAF_VRIMPITMAF,
                                             @V_IMPOSTOAF_CDIMPOSTO   , @V_IMPOSTOAF_IDTRATIMPO,
                                             @V_IMPOSTOAF_CDFISCITMAF , @V_IMPOSTOAF_IDIMPORECUP,
                                             @V_IMPOSTOAF_VRLIQUIDO;

            WHILE (@@FETCH_STATUS = 0)
            BEGIN

               IF (@V_ENC_IDENCARGO = 'A')
               BEGIN
                  SET @V_PRODUENCARGO = +(@V_ENC_VRENCARGOAF/@V_TOTAPRODENCA)*@V_IMPOSTOAF_VRLIQUIDO;
               END
               ELSE IF (@V_ENC_IDENCARGO = 'D')
               BEGIN
                  SET @V_PRODUENCARGO = -(@V_ENC_VRENCARGOAF/@V_TOTAPRODENCA)*@V_IMPOSTOAF_VRLIQUIDO;
               END
               ELSE
               BEGIN
                  SET @V_PRODUENCARGO = 0;
               END;

               SET @V_TAXABASECALC = (100 - @V_IMPOSTOAF_VRPERREDBCAF)/100;
               SET @V_TAXAALIQUOTA = (@V_IMPOSTOAF_VRALIQITMAF/100);

               SET @V_ADIMPAF = 0;

               IF (@V_IMPOSTOAF_IDTRATIMPO = 'A')
               BEGIN
                  SET @V_ADIMPAF = ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQUOTA);

               END
               ELSE IF (@V_IMPOSTOAF_IDTRATIMPO = 'D')
               BEGIN
                  SET @V_ADIMPAF = - ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQUOTA);

               END;

--- * RETIRADO PARA TRATAMENTO SOMENTE NA GERACAO DE VENCIMENTO
--               ELSIF (@V_IMPOSTOAF_IDTRATIMPO  = 'R') THEN
--                  IF (@V_IMPOSTOAF_IDIMPORECUP = 'S') THEN
--                     IF (@V_CARACFIS = 'N' OR (@V_CARACFIS  = 'C' AND @V_IMPOSTOAF_CDFISCITMAF <> '1')) THEN
--                        @V_ADIMPAF = - ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
--                     END IF;
--                  ELSE
--                     @V_ADIMPAF = - ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
--                  END IF;
--               END IF;


               IF (@V_IMPOSTOAF_IDTRATIMPO <> 'V')
               BEGIN
                  UPDATE IMPITMAF
                  SET VRIMPITMAF   = ROUND(VRIMPITMAF   + ((@V_PRODUENCARGO * @V_TAXABASECALC) * @V_TAXAALIQUOTA), 2),
                      VRBASECALCAF = VRBASECALCAF + (@V_PRODUENCARGO * @V_TAXABASECALC),
                      VRADIMPAF    = ROUND(VRADIMPAF    + @V_ADIMPAF, 2)
                  WHERE (CDFILLANC   = @P_FILLANC)              AND
                        (CDFILDEST   = @P_FILDEST)              AND
                        (NRAUTOFORN  = @P_LANCTOAF)             AND
                        (CDPRODUTO   = @V_IMPOSTOAF_CDPRODUTO)  AND
                        (CDMARCA     = @V_IMPOSTOAF_CDMARCA)    AND
                        (CDIMPOSTO   = @V_IMPOSTOAF_CDIMPOSTO)  AND
                        (DTPROGENTAF = @V_DATAITEM_DTPROGENTAF);
               END;
               FETCH NEXT FROM C_IMPOSTOAF INTO @V_IMPOSTOAF_CDPRODUTO,@V_IMPOSTOAF_CDMARCA,
                                                @V_IMPOSTOAF_VRPERREDBCAF, @V_IMPOSTOAF_VRALIQITMAF,
                                                @V_IMPOSTOAF_VRPARCDEDAF , @V_IMPOSTOAF_VRIMPITMAF,
                                                @V_IMPOSTOAF_CDIMPOSTO   , @V_IMPOSTOAF_IDTRATIMPO,
                                                @V_IMPOSTOAF_CDFISCITMAF , @V_IMPOSTOAF_IDIMPORECUP,
                                                @V_IMPOSTOAF_VRLIQUIDO;
            END;
            CLOSE C_IMPOSTOAF;
            DEALLOCATE C_IMPOSTOAF;
         END;
         FETCH NEXT FROM C_ENCARGO INTO @V_ENC_CDENCARGO, @V_ENC_VRENCARGOAF,
                                        @V_ENC_IDENCARGO;
      END;
      CLOSE C_ENCARGO;
      DEALLOCATE C_ENCARGO;
      FETCH NEXT FROM C_DATAITEM INTO @V_DATAITEM_DTPROGENTAF;
   END;

   CLOSE C_DATAITEM;
   DEALLOCATE C_DATAITEM;

---------------------------------------------------------------------------------------------------------
--Clculo do Valor dos Impostos que contm outros impostos na sua Base de Clculo

   DECLARE C_PRODUTO CURSOR FOR
   SELECT IP.CDPRODUTO, IP.CDMARCA, IP.DTPROGENTAF, II.CDIMPOSTO, VRPERREDBCAF,
          VRALIQITMAF, VRPARCDEDAF, CDFISCITMAF, VRIMPITMAF, IDTRATIMPO,
          IM.IDIMPORECUP
   FROM ITEMAUTF IP, IMPITMAF II, IMPOSTO IM
   WHERE (IP.CDFILLANC   = @P_FILLANC)      AND
         (IP.CDFILDEST   = @P_FILDEST)      AND
         (IP.NRAUTOFORN  = @P_LANCTOAF)     AND
         (II.CDFILLANC   = @P_FILLANC)      AND
         (II.CDFILDEST   = @P_FILDEST)      AND
         (II.NRAUTOFORN  = @P_LANCTOAF)     AND
         (II.CDPRODUTO   = IP.CDPRODUTO)   AND
         (II.CDMARCA     = IP.CDMARCA)     AND
         (II.DTPROGENTAF = IP.DTPROGENTAF) AND
         (II.IDIMPDIGAF  = 'N')            AND
         (IM.CDIMPOSTO   = II.CDIMPOSTO);

   OPEN C_PRODUTO;
   FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDPRODUTO ,@V_PRODUTO_CDMARCA,
                                  @V_PRODUTO_DTPROGENTAF , @V_PRODUTO_CDIMPOSTO,
                                  @V_PRODUTO_VRPERREDBCAF, @V_PRODUTO_VRALIQITMAF,
                                  @V_PRODUTO_VRPARCDEDAF , @V_PRODUTO_CDFISCITMAF,
                                  @V_PRODUTO_VRIMPITMAF  , @V_PRODUTO_IDTRATIMPO,
                                  @V_PRODUTO_IDIMPORECUP;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_AUX = @P_FILDEST+@P_FILLANC;
      EXEC CONSULTA_CST 'E', @P_EMPRESA, @V_PRODUTO_CDPRODUTO, @P_INSCESTA, @V_TIPOOPER,
                        @V_AUX, @P_LANCTOAF, @V_CDGRUPOFISC, @V_IDCSTINTEREST, @V_IDCSTINTERNA;

      EXEC CONSULTA_CFOP 'E', @P_EMPRESA, @V_PRODUTO_CDPRODUTO, @P_INSCESTA, @V_TIPOOPER, @V_PAISORIG,
                         @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_AUX, @P_LANCTOAF,
                         @V_CDGRUPOFISC, @V_PRODUTO_DTPROGENTAF;

      SET @V_FISOPEITEM = NULL;
      SELECT @V_FISOPEITEM = MAX(CDFISOPETMP)
      FROM CFOPTEMP
      WHERE NRCFOPTEMP = @V_CFOPTEMP;

      SET @V_SITUTRIBPR = NULL;
      SELECT @V_SITUTRIBPR = MAX(CDSITTRIBTMP)
      FROM CSTTEMP
      WHERE NRCSTTEMP = @V_CSTTEMP;

      SET @V_TOTAIMPBCALC  = NULL;
      SET @V_IDTRATIMPBC   = NULL;
      SET @V_IDIMPORECUPBC = NULL;
      SET @V_CDIMPOBCALTPOP = NULL;

      SELECT @V_CDIMPOBCALTPOP = MAX(BC.CDIMPOBCALC),
             @V_TOTAIMPBCALC   = SUM(VRIMPITMAF),
             @V_IDTRATIMPBC    = MAX(IMPOSTO.IDTRATIMPO),
             @V_IDIMPORECUPBC  = MAX(IDIMPORECUP)
        FROM ITEMAUTF IP, IMPITMAF II, BASECALCTPOPER BC, IMPOSTO
       WHERE (BC.IDENTRSAIDOP = 'E')
         AND (BC.CDTIPOOPER   = @V_TIPOOPER)
         AND (BC.CDIMPOSTO    = @V_PRODUTO_CDIMPOSTO)
         AND (IP.CDFILLANC    = @P_FILLANC)
         AND (IP.CDFILDEST    = @P_FILDEST)
         AND (IP.NRAUTOFORN   = @P_LANCTOAF)
         AND (II.CDFILLANC    = @P_FILLANC)
         AND (II.CDFILDEST    = @P_FILDEST)
         AND (II.NRAUTOFORN   = @P_LANCTOAF)
         AND (IP.CDPRODUTO    = @V_PRODUTO_CDPRODUTO)
         AND (IP.CDMARCA      = @V_PRODUTO_CDMARCA)
         AND (IP.DTPROGENTAF  = @V_PRODUTO_DTPROGENTAF)
         AND (II.CDPRODUTO    = @V_PRODUTO_CDPRODUTO)
         AND (II.CDMARCA      = @V_PRODUTO_CDMARCA)
         AND (II.DTPROGENTAF  = @V_PRODUTO_DTPROGENTAF)
         AND (II.IDIMPDIGAF   = 'N')
         AND (II.CDIMPOSTO    = BC.CDIMPOBCALC)
         AND (IMPOSTO.CDIMPOSTO = BC.CDIMPOBCALC)
         AND ((SUBSTRING(@V_SITUTRIBPR,2,2) = BC.CDCSTIMPOTPOP)  OR (BC.CDCSTIMPOTPOP  IS NULL))
         AND ((SUBSTRING(@V_FISOPEITEM,2,10) = BC.CDCFOPIMPOTPOP) OR (BC.CDCFOPIMPOTPOP IS NULL))
         AND ((II.CDFISCITMAF = BC.CDFISCIMPOTPOP) OR (BC.CDFISCIMPOTPOP IS NULL));

      IF @V_CDIMPOBCALTPOP IS NULL BEGIN
         SELECT @V_TOTAIMPBCALC  = SUM(VRIMPITMAF),
                @V_IDTRATIMPBC   = MAX(IMPOSTO.IDTRATIMPO),
                @V_IDIMPORECUPBC = MAX(IDIMPORECUP)
         FROM ITEMAUTF IP, IMPITMAF II, BASECALC BC, IMPOSTO
         WHERE (BC.CDIMPOSTO   = @V_PRODUTO_CDIMPOSTO)   AND
               (IP.CDFILLANC   = @P_FILLANC)             AND
               (IP.CDFILDEST   = @P_FILDEST)             AND
               (IP.NRAUTOFORN  = @P_LANCTOAF)            AND
               (II.CDFILLANC   = @P_FILLANC)             AND
               (II.CDFILDEST   = @P_FILDEST)             AND
               (II.NRAUTOFORN  = @P_LANCTOAF)            AND
               (IP.CDPRODUTO   = @V_PRODUTO_CDPRODUTO)   AND
               (IP.CDMARCA     = @V_PRODUTO_CDMARCA)     AND
               (IP.DTPROGENTAF = @V_PRODUTO_DTPROGENTAF) AND
               (II.IDIMPDIGAF  = 'N')                    AND
               (II.CDPRODUTO   = @V_PRODUTO_CDPRODUTO)   AND
               (II.CDMARCA     = @V_PRODUTO_CDMARCA)     AND
               (II.DTPROGENTAF = @V_PRODUTO_DTPROGENTAF) AND
               (II.CDIMPOSTO   = BC.CDIMPOBCALC)        AND
               (IMPOSTO.CDIMPOSTO = BC.CDIMPOBCALC)     AND
               ((SUBSTRING(@V_SITUTRIBPR,2,2) = BC.CDCSTIMPO)  OR (BC.CDCSTIMPO  IS NULL)) AND
               ((SUBSTRING(@V_FISOPEITEM,2,10) = BC.CDCFOPIMPO) OR (BC.CDCFOPIMPO IS NULL)) AND
               ((II.CDFISCITMAF = BC.CDFISCIMPO) OR (BC.CDFISCIMPO IS NULL)) AND
               (BC.IDTIPOBCALC   = 'I');
      END;

      DELETE FROM CFOPTEMP
      WHERE NRCFOPTEMP = @V_CFOPTEMP;

      DELETE FROM CSTTEMP
      WHERE NRCSTTEMP = @V_CSTTEMP;

      IF NOT (@V_TOTAIMPBCALC IS NULL)
      BEGIN
         SET @V_TAXABASECALC = (100 - @V_PRODUTO_VRPERREDBCAF)/100;
         SET @V_TAXAALIQUOTA = (@V_PRODUTO_VRALIQITMAF/100);

         SET @V_ADIMPAF = 0;

         IF (@V_IDTRATIMPBC = 'A')
         BEGIN
            SET @V_ADIMPAF = ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);

         END
         ELSE IF (@V_IDTRATIMPBC = 'D')
         BEGIN
            SET @V_ADIMPAF = - ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);

         END
         ELSE IF (@V_IDTRATIMPBC  = 'R')
         BEGIN
            IF (@V_IDIMPORECUPBC = 'S')
            BEGIN
               IF (/*@V_CARACFIS = 'N' OR (@V_CARACFIS  = 'C' AND*/ @V_PRODUTO_CDFISCITMAF <> '1')
               BEGIN
                  SET @V_ADIMPAF = - ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
               END;
            END
            ELSE
            BEGIN
               SET @V_ADIMPAF = - ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA);
            END;
         END;

         IF (@V_IMPOSTOAF_IDTRATIMPO <> 'V')
         BEGIN
            UPDATE IMPITMAF
            SET VRBASECALCAF = VRBASECALCAF + (@V_TOTAIMPBCALC * @V_TAXABASECALC),
                VRIMPITMAF   = ROUND(VRIMPITMAF   + ((@V_TOTAIMPBCALC * @V_TAXABASECALC) * @V_TAXAALIQUOTA), 2),
                VRADIMPAF    = ROUND(VRADIMPAF    + @V_ADIMPAF, 2)
            WHERE (CDFILLANC   = @P_FILLANC)             AND
                  (CDFILDEST   = @P_FILDEST)             AND
                  (NRAUTOFORN  = @P_LANCTOAF)            AND
                  (CDPRODUTO   = @V_PRODUTO_CDPRODUTO)   AND
                  (CDMARCA     = @V_PRODUTO_CDMARCA)     AND
                  (DTPROGENTAF = @V_PRODUTO_DTPROGENTAF) AND
                  (CDIMPOSTO   = @V_PRODUTO_CDIMPOSTO);
         END;
      END;
      FETCH NEXT FROM C_PRODUTO INTO @V_PRODUTO_CDPRODUTO   , @V_PRODUTO_CDMARCA,
                                     @V_PRODUTO_DTPROGENTAF , @V_PRODUTO_CDIMPOSTO,
                                     @V_PRODUTO_VRPERREDBCAF, @V_PRODUTO_VRALIQITMAF,
                                     @V_PRODUTO_VRPARCDEDAF , @V_PRODUTO_CDFISCITMAF,
                                     @V_PRODUTO_VRIMPITMAF  , @V_PRODUTO_IDTRATIMPO,
                                     @V_PRODUTO_IDIMPORECUP;
   END;
   DEALLOCATE C_PRODUTO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTO_ITEMAF','5.85.xxx';
GO

